=== debian/changelog ===
mame (0.276+dfsg.1-1+rpi1+deb13u1) trixie-staging; urgency=medium

  [changes brought forward from 0.261+dfsg.1-1+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Thu, 22 Feb 2024 05:43:15 +0000]
  * Use --long-plt on armhf too.

 -- Raspbian forward porter <root@raspbian.org>  Sun, 14 Sep 2025 05:37:41 +0000

mame (0.276+dfsg.1-1+deb13u1) trixie; urgency=medium

  * Build translations explicitly in the -build-indep target.
    Translations have been missing since the build was split
    (closes: #1109978).

 -- Jordi Mallach <jordi@debian.org>  Wed, 20 Aug 2025 13:02:00 +0200
