## mame 0.277%2Bdfsg.1

=== debian/changelog ===
mame (0.277+dfsg.1-4ubuntu0.1) questing-security; urgency=medium

  * SECURITY UPDATE: Possible heap-based buffer over-read
    - debian/patches/CVE-2022-34300.patch: Fix out of bounds access in
    DecodePixelData
    - CVE-2022-34300

 -- Chrisa Oikonomou <chrisa.oikonomou@canonical.com>  Mon, 24 Nov 2025 16:46:07 +0200

mame (0.277+dfsg.1-4) unstable; urgency=medium

  * Enable FORCE_DRC_C_BACKEND for riscv64, as was done for alpha and ia64
    in the past (closes: #1104825).

 -- Jordi Mallach <jordi@debian.org>  Wed, 14 May 2025 17:50:55 +0200

mame (0.277+dfsg.1-3) unstable; urgency=medium

  * Restore riscv64 part of a patch that was accidentally dropped during
    rebase.

 -- Jordi Mallach <jordi@debian.org>  Sun, 04 May 2025 22:28:24 +0200

mame (0.277+dfsg.1-2) unstable; urgency=medium

  [ Cesare Falco ]
  * New, temporary patch ftbfs_armhf_missing_asmjit.patch
    (upstream commit b4e1f5f1b50fd3402232dd0385cac021ba488db6)

 -- Jordi Mallach <jordi@debian.org>  Sun, 04 May 2025 10:45:06 +0200

mame (0.277+dfsg.1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.

  [ Jordi Mallach ]
  * Refresh patches.

 -- Jordi Mallach <jordi@debian.org>  Sun, 04 May 2025 00:57:28 +0200
