=== debian/rules ===
--- 
+++ 
@@ -93,7 +93,6 @@
 
 ifeq ($(DEB_HOST_ARCH),armhf)
 export DEB_LDFLAGS_MAINT_APPEND += -Wl,--allow-multiple-definition
-export DEB_LDFLAGS_MAINT_APPEND += -Wl,--long-plt
 endif
 
 ifeq ($(DEB_HOST_ARCH),hppa)
@@ -250,11 +249,9 @@
 
 override_dh_auto_build-indep:
 	$(MAKE) -C docs singlehtml
-	find language -mindepth 1 -type d -execdir msgfmt {}/strings.po -o {}/strings.mo \;
 
 override_dh_auto_clean:
 	PYTHON_EXECUTABLE=python3 dh_auto_clean
-	find language -name "*.mo" -delete
 
 override_dh_auto_test-arch:
 	# Run MAME's internal validation tests
