## mame 0.278+dfsg.1

=== debian/changelog ===
mame (0.278+dfsg.1-0.1~mx23+1) mx; urgency=medium

  * New upstream release.
  * Disable patches for arches not supported in MX.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 12 Jul 2025 07:08:09 -0700
