## mame 0.279+dfsg.1

=== debian/changelog ===
mame (0.279+dfsg.1-2) unstable; urgency=medium

  * Just generate the translation .mo files with msgfmt.
  * Do not refer to the FSF old postal address in copyright file.

 -- Jordi Mallach <jordi@debian.org>  Tue, 19 Aug 2025 16:38:07 +0200

mame (0.279+dfsg.1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.
  * Update patches.

  [ Jordi Mallach ]
  * Build translations explicitly in the -build-indep target
    (closes: #1109978).
  * Update syntax for source lintian overrides and remove unused ones.

 -- Jordi Mallach <jordi@debian.org>  Tue, 19 Aug 2025 10:12:25 +0200

mame (0.278+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Patches audit & review
    + Removed temporary patch ftbfs_armhf_missing_asmjit.patch
    + Removed long-time-commented patches
    + Refreshed others

 -- Cesare Falco <c.falco@ubuntu.com>  Tue, 01 Jul 2025 15:27:23 +0200
