## mame 0.280%2Bdfsg.1

=== debian/changelog ===
mame (0.280+dfsg.1-2) unstable; urgency=medium

  * Add missing Build-Dep on sphinx-common for the dh addon.

 -- Jordi Mallach <jordi@debian.org>  Fri, 05 Sep 2025 00:41:08 +0200

mame (0.280+dfsg.1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.

  [ Jordi Mallach ]
  * Build-Depend on libfontconfig-dev instead of obsolete libfontconfig1-dev.
  * Correct copyright-related lintian errors.
  * Use dh_sphinxdoc to generate symlinks to common js files.
  * Build the html version of the docs instead of singlehtml.

 -- Jordi Mallach <jordi@debian.org>  Thu, 04 Sep 2025 14:46:11 +0200
